#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#define WIN32_LEAN_AND_MEAN
#define u8	unsigned char
#define u16	unsigned short
#define u32	unsigned int
char filename_usb3_init[] = "usb3_descrip_rom.init";
char filename_descrip_vh[] = "usb_descrip.vh";

FILE   *init_3, *descrip_vh;

u8	bitwidth_3;
u8	*a;
u8	q;
u8	r;



u32 config_length;
u32 bos_length;
u32 i_3;


u8	buf_2[1024] = {0, };

void fail(void *ret, char *str)
{
	if(ret == NULL){
		printf("\n* FAIL: %s\n", str);
		exit(-1);
	}
}

void cal_offset ( u8 inc_byte )
{
	q = inc_byte / 4 ;
	r = inc_byte - q * 4 ;
	
	if ( r > 0 ) 
		i_3 += (inc_byte/4) + 1;
	else 	
		i_3 += inc_byte/4 ;
	
	printf("inc_byte = %d \n", inc_byte);
	printf("q = %d \n", q);
	printf("r = %d \n", r);
	printf("i_3 = %d \n", i_3);
	
}
void print_offsets(char *name)
{
	fprintf(descrip_vh, "parameter\t[%d:0]\tDESCR_USB3_%s	= 'd%d;\n", bitwidth_3-1, name, i_3   );
}

void print_length(char *name , u8 len )
{
	fprintf(descrip_vh, "parameter\t[%d:0]\tDESCR_USB3_%s	= 'd%d;\n", bitwidth_3-1, name, len   );
	cal_offset ( len )	;
}
void write_buf32(u32 *buf, u32 size)
{
	u32 i, w;
	for(i = 0; i < size; i+=4){
		w = *buf;
		w = (w & 0xff) << 24 | (w & 0xff00) << 8 | (w & 0xff0000) >> 8 | (w & 0xff000000) >> 24 ;
		fprintf(init_3, "%08X\n", w);
		*buf++;
	}
}


void add_device_descr(u16 usb_spec, u8 class_code, u8 subclass, u8 protocol_code, u8 max_size_ep0,
					 u16 vid, u16 pid, u16 dev_num,
					 u8 idx_mfg, u8 idx_prod, u8 idx_serial, u8 num_possible_config)
{
	a = buf_2;

	*a++ = 0x12;					// length
	*a++ = 0x01;					// descriptor ID
	*a++ = (usb_spec&0xff); 		// bcdUSB
	*a++ = (usb_spec>>8); 			// bcdUSB 	

	*a++ = class_code;				// bDeviceClass
	*a++ = subclass;				// bDeviceSubClass
	*a++ = protocol_code;			// bDeviceProtocol
	*a++ = max_size_ep0;			// USB3: 512 bytes fixed EP0
	
	*a++ = (vid&0xff);
	*a++ = (vid>>8);
	*a++ = (pid&0xff);
	*a++ = (pid>>8);
	
	*a++ = (dev_num&0xff);
	*a++ = (dev_num>>8);
	*a++ = idx_mfg;
	*a++ = idx_prod;
	
	*a++ = idx_serial;
	*a++ = num_possible_config;		// bNumConfigurations
	
	write_buf32((u32 *)buf_2, 18 );   	
	
	


}

void add_config_descr( u8 intf_num , u8 config_val , u8 attrib, u8 power_ma )
{
	a = buf_2;
	



	// write Config descriptor
	*a++ = 0x09;				// length
	*a++ = 0x02;				// descriptor ID
	*a++ = 0x00;       			// wTotalLength rewrite later
	*a++ = 0x00;   				//
	
	*a++ = intf_num;			// bNumInterfaces
	*a++ = config_val;			// bConfigurationValue
	*a++ = 0x00;				// iConfiguration
	*a++ = attrib;				// bmAttributes
	
	*a++ = power_ma;			// MaxPower
		
	config_length += 9 ;
}

void add_intf_descr ( u8 intf_num , u8 alt_set , u8 endpt_num, u8 intf_class ,u8 intf_SubClass, u8 intf_prot , u8 idx_intf )
{

	// write Interface descriptor
	*a++ = 0x09;				// length
	*a++ = 0x04;				// descriptor ID
	*a++ = intf_num;			// bInterfaceNumber
	*a++ = alt_set;				// bAlternateSetting
	*a++ = endpt_num;			// bNumEndpoints
	*a++ = intf_class;			// bInterfaceClass
	*a++ = intf_SubClass;		// bInterfaceSubClass
	*a++ = intf_prot;			// bInterfaceProtocol
	*a++ = idx_intf;			// iInterface
		
	config_length += 9 ;
}

void add_endpt_descr (u8 endpt_addr ,  u8 attrib, u16 max_pkt, u8 interval )
{
	
	// write Endpoint descriptor
	*a++ = 0x07;				// length
	*a++ = 0x05;				// descriptor ID
	*a++ = endpt_addr;
	*a++ = attrib;				// bmAttributes
	*a++ = (max_pkt&0xff);	    // max packet size
	*a++ = (max_pkt>>8);	    // max packet size
	*a++ = interval;			// bInterval

	config_length += 7 ;
	

}


void add_endpt_c_descr ( u8 max_burst , u8 attrib_3 , u16 bytes_per_interval )
{
	
	// add companion descriptor only to USB3 buffer
	*a++ = 0x06;				// length
	*a++ = 0x30;				// descriptor ID
	*a++ = max_burst;
	*a++ = attrib_3;			// bmAttributes
	*a++ = (bytes_per_interval&0xff); // wBytesPerInterval
	*a++ = (bytes_per_interval>>8);	  // wBytesPerInterval

	config_length += 6 ;	
}

void cal_config_descr_length()

{
	
	a = buf_2 + 2 ;
	*a++ = (config_length&0xff) ;
	*a++ = (config_length>>8) ;
	
	
	
	write_buf32((u32 *)buf_2, config_length );  
	
	
}


void cal_bos_desc_length()

{
	
	a = buf_2 + 2 ;
	*a++ = (bos_length&0xff) ;
	*a++ = (bos_length>>8) ;
	
	
	write_buf32((u32 *)buf_2, bos_length );  
	
	
	
}


void add_bos_descr( u8 NumDeviceCaps ) 

{
	

	
	a = buf_2 ;				
	*a++ = 0x05 ;			// bLength  
	*a++ = 0x0f ;	        // bDescriptorType
	*a++ = 0x00 ;			// wTotalLength rewrite later
	*a++ = 0x00 ;			//
	*a++ = NumDeviceCaps ;	// bNumDeviceCaps
	
	bos_length += 5 ;
	
	
}

void add_usb20_ext_desc( u32 bmAttributes)

{
	*a++ = 0x07 ;					//bLength
	*a++ = 0x10 ;					//bDescriptorType
	*a++ = 0x02 ;					//bDevCapabilityType
	*a++ = bmAttributes & 0xff ;	//bmAttributes
	*a++ = (bmAttributes >> 8 ) ;
	*a++ = 0x00   ;
	*a++ = 0x00   ;
	
	bos_length += 7 ;
	
		
}

void add_usb_dev_cap_desc ( u8 bmAttributes , u16 wSpeedsSupported ,  u8 bFunctionalitySupport , u8 bU1DevExitLat , u16 wU2DevExitLat )

{
	*a++ = 0x0A ;						//bLength
	*a++ = 0x10 ;						//bDescriptorType
	*a++ = 0x03 ;						//bDevCapabilityType
	*a++ = bmAttributes ;				//bmAttributes
	*a++ = (wSpeedsSupported&0xff) ;	//wSpeedsSupported
	*a++ = (wSpeedsSupported>>8) ;		//
	*a++ = bFunctionalitySupport ;		//bFunctionalitySupport
	*a++ = bU1DevExitLat ;				//bU1DevExitLat
	*a++ = (wU2DevExitLat&0xff) ;		//wU2DevExitLat
	*a++ = (wU2DevExitLat>>8);			//
	
	bos_length += 10 ;
	
}


void add_string_desc_0 ( u16 Language_ID ) 
{
	a = buf_2;
	
	*a++ = 0x04 ;	
	*a++ = 0x03 ;	
	*a++ = (Language_ID&0xff) ;
	*a++ = (Language_ID>>8) ;
	
}

void add_string_desc_MSFT ()
{
	a = buf_2 ;
	
	*a++ = 0x12 ;	
	*a++ = 0x03 ;	

	*a++ = 0x4D	;
	*a++ = 0x00 ;
	*a++ = 0x53 ;
	*a++ = 0x00 ;
	*a++ = 0x46 ;
	*a++ = 0x00 ;
	*a++ = 0x54 ;
	*a++ = 0x00 ;
	*a++ = 0x31 ;
	*a++ = 0x00 ;
	*a++ = 0x30 ;
	*a++ = 0x00 ;
	*a++ = 0x30 ;
	*a++ = 0x00 ;

	*a++ = 0x00 ;
	*a++ = 0x00 ;

	
}

void cal_string_desc_0_length()

{
	
	write_buf32((u32 *)buf_2, 4 );  
	
	
	
}

void cal_string_desc_MSFT_length()
{
	
	write_buf32((u32 *)buf_2, 18 );		
	
}




int main(int argc, char *argv[])
{
	printf("\n* USB 3.0 descriptor export tool\n ");
	
	fail(init_3 = fopen(filename_usb3_init, "w"), "Failed opening USB3.0 INIT");	
	
	fail(descrip_vh = fopen(filename_descrip_vh, "w"), "Failed opening descriptor include");
	
	// set your BRAM address bit widths
	bitwidth_3 = 7;	// [6:0]
	
	i_3 = 0 ;
		
	printf ("* Generating...\n");
	
	print_offsets("DEVICE");
	add_device_descr(	0x300,		// USB spec number 
									// 
						0x00,		// Class Code
						0x00,		// Subclass
						0x00,		// Protocol Code
						9,			// Endpoint0 Max packet (ignored for 3.0)
						0x05E3,		// Vendor ID
						0x0749,		// Product ID
						0x1532,		// Device release number
						00,			// Index of Manufacturer Str Descriptor
						00,			// Index of Product Str Descriptor
						00,			// Index of Serial Number Str Descriptor
						1			// Number of  Configs
					);	
	print_length("DEVICE_LEN",18);				
	
						
	print_offsets("CONFIG");	
	add_config_descr(
						0x01,		// bNumInterfaces
						0x01,		// bConfigurationValue
						0x80,		// attributes (self powered)
						0x70		// Power draw in mA	
					);	
					
	add_intf_descr(
						0x00,		//bInterfaceNumber
						0x00,       //bAlternateSetting
						0x02,       //bNumEndpoints
						0x08,       //bInterfaceClass
						0x06,       //bInterfaceSubClass 
						0x50,       //bInterfaceProtocol
						0x00        //iInterface
	);	

	add_endpt_descr(
						0x81,		//bEndpointAddress
						0x02,		//bmAttributes
						0x0400,		//wMaxPacketSize
						0x00		//bInterval
	);	
	
	add_endpt_c_descr(
						0x04 ,		//bMaxBurst
						0x00 ,		//bmAttributes	
						0x0000		//wBytesPerInterval
	
	);
	
	add_endpt_descr(
						0x02,		//bEndpointAddress
						0x02,		//bmAttributes
						0x0400,		//wMaxPacketSize
						0x00		//bInterval
	);

	add_endpt_c_descr(
						0x04 ,		//bMaxBurst
						0x00 ,		//bmAttributes	
						0x0000		//wBytesPerInterval
	
	);	
	
	cal_config_descr_length();
	print_length("CONFIG_LEN",config_length);	
	
	
	print_offsets("BOS");
	
	add_bos_descr(
						0x02 	 //bNumDeviceCaps 
			
	);
	
	add_usb20_ext_desc(
						0xF0E	//bmAttributes			
	);
		

	add_usb_dev_cap_desc(
						0x00, 	//bmAttributes
						0x0E,	//wSpeedsSupported
						0x01,	//bFunctionalitySupport
						0x0A,	//bU1DevExitLat
						0x07FF  //wU2DevExitLat
	
	);	

	cal_bos_desc_length ();	
	print_length("BOS_LEN",bos_length);	
	
	print_offsets("STR0");
	
	add_string_desc_0(
						0x0409 // Language ID[0]	
	);
	
	cal_string_desc_0_length();
	print_length("STR0_LEN",4);
	
	
	print_offsets("STR_MSFT");
	
	add_string_desc_MSFT(
						
	);
	
	cal_string_desc_MSFT_length();
	print_length("STR_MSFT_LEN",18);	
	
	printf("* Finished\n");				
	fclose(init_3);
	fclose(descrip_vh);					

}