`include "UserEndpt_define.v"	

module UserLayer_top 
(

	 input pclk 
	,input phy_resetn

	// requests
	,input wire			request_active 	
	,input wire	[7:0]	bmRequestType	
	,input wire	[7:0]	bRequest		
	,input wire	[15:0]	wValue			
	,input wire	[15:0]	wIndex			
	,input wire	[15:0]	wLength	

	// ep0 IN  
	,output	wire	[31:0]	ep0_in_buf_data
	,output	wire			ep0_in_buf_wren
	,input	wire			ep0_in_buf_ready
	,output	wire			ep0_in_buf_data_commit
	,output	wire	[10:0]	ep0_in_buf_data_commit_len		

	// ep0 OUT	
	,input  wire	[31:0]	ep0_out_buf_data		 	
	,input  wire	[10:0]	ep0_out_buf_len		
	,input  wire			ep0_out_buf_has_data	
	,output wire			ep0_out_buf_rden
	,output wire			ep0_out_buf_data_ack		


	`ifdef ENDPT1_IN 
	,output	wire	[31:0]	ep1_in_buf_data
	,output	wire			ep1_in_buf_wren
	,input	wire			ep1_in_buf_ready
	,output	wire			ep1_in_buf_data_commit
	,output	wire	[10:0]	ep1_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT1_OUT
	,input	wire	[31:0]	ep1_out_buf_data
	,input	wire	[10:0]	ep1_out_buf_len
	,input	wire			ep1_out_buf_has_data
	,output wire 			ep1_out_buf_rden
	,output	wire			ep1_out_buf_data_ack 
	`endif	
	
	`ifdef ENDPT2_IN 
	,output	wire	[31:0]	ep2_in_buf_data
	,output	wire			ep2_in_buf_wren
	,input	wire			ep2_in_buf_ready
	,output	wire			ep2_in_buf_data_commit
	,output	wire	[10:0]	ep2_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT2_OUT
	,input	wire	[31:0]	ep2_out_buf_data
	,input	wire	[10:0]	ep2_out_buf_len
	,input	wire			ep2_out_buf_has_data
	,output wire 			ep2_out_buf_rden
	,output	wire			ep2_out_buf_data_ack 
	`endif	
	
	`ifdef ENDPT3_IN 
	,output	wire	[31:0]	ep3_in_buf_data
	,output	wire			ep3_in_buf_wren
	,input	wire			ep3_in_buf_ready
	,output	wire			ep3_in_buf_data_commit
	,output	wire	[10:0]	ep3_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT3_OUT
	,input	wire	[31:0]	ep3_out_buf_data
	,input	wire	[10:0]	ep3_out_buf_len
	,input	wire			ep3_out_buf_has_data
	,output wire 			ep3_out_buf_rden
	,output	wire			ep3_out_buf_data_ack 
	`endif

	`ifdef ENDPT4_IN 
	,output	wire	[31:0]	ep4_in_buf_data
	,output	wire			ep4_in_buf_wren
	,input	wire			ep4_in_buf_ready
	,output	wire			ep4_in_buf_data_commit
	,output	wire	[10:0]	ep4_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT4_OUT
	,input	wire	[31:0]	ep4_out_buf_data
	,input	wire	[10:0]	ep4_out_buf_len
	,input	wire			ep4_out_buf_has_data
	,output wire 			ep4_out_buf_rden
	,output	wire			ep4_out_buf_data_ack 
	`endif	

	`ifdef ENDPT5_IN 
	,output	wire	[31:0]	ep5_in_buf_data
	,output	wire			ep5_in_buf_wren
	,input	wire			ep5_in_buf_ready
	,output	wire			ep5_in_buf_data_commit
	,output	wire	[10:0]	ep5_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT5_OUT
	,input	wire	[31:0]	ep5_out_buf_data
	,input	wire	[10:0]	ep5_out_buf_len
	,input	wire			ep5_out_buf_has_data
	,output wire 			ep5_out_buf_rden
	,output	wire			ep5_out_buf_data_ack 
	`endif	

	`ifdef ENDPT6_IN 
	,output	wire	[31:0]	ep6_in_buf_data
	,output	wire			ep6_in_buf_wren
	,input	wire			ep6_in_buf_ready
	,output	wire			ep6_in_buf_data_commit
	,output	wire	[10:0]	ep6_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT6_OUT
	,input	wire	[31:0]	ep6_out_buf_data
	,input	wire	[10:0]	ep6_out_buf_len
	,input	wire			ep6_out_buf_has_data
	,output wire 			ep6_out_buf_rden
	,output	wire			ep6_out_buf_data_ack 
	`endif		
	
	`ifdef ENDPT7_IN 
	,output	wire	[31:0]	ep7_in_buf_data
	,output	wire			ep7_in_buf_wren
	,input	wire			ep7_in_buf_ready
	,output	wire			ep7_in_buf_data_commit
	,output	wire	[10:0]	ep7_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT7_OUT
	,input	wire	[31:0]	ep7_out_buf_data
	,input	wire	[10:0]	ep7_out_buf_len
	,input	wire			ep7_out_buf_has_data
	,output wire 			ep7_out_buf_rden
	,output	wire			ep7_out_buf_data_ack 
	`endif		
	
	`ifdef ENDPT8_IN 
	,output	wire	[31:0]	ep8_in_buf_data
	,output	wire			ep8_in_buf_wren
	,input	wire			ep8_in_buf_ready
	,output	wire			ep8_in_buf_data_commit
	,output	wire	[10:0]	ep8_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT8_OUT
	,input	wire	[31:0]	ep8_out_buf_data
	,input	wire	[10:0]	ep8_out_buf_len
	,input	wire			ep8_out_buf_has_data
	,output wire 			ep8_out_buf_rden
	,output	wire			ep8_out_buf_data_ack 
	`endif	
	
	`ifdef ENDPT9_IN 
	,output	wire	[31:0]	ep9_in_buf_data
	,output	wire			ep9_in_buf_wren
	,input	wire			ep9_in_buf_ready
	,output	wire			ep9_in_buf_data_commit
	,output	wire	[10:0]	ep9_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT9_OUT
	,input	wire	[31:0]	ep9_out_buf_data
	,input	wire	[10:0]	ep9_out_buf_len
	,input	wire			ep9_out_buf_has_data
	,output wire 			ep9_out_buf_rden
	,output	wire			ep9_out_buf_data_ack 
	`endif
	
	`ifdef ENDPT10_IN 
	,output	wire	[31:0]	ep10_in_buf_data
	,output	wire			ep10_in_buf_wren
	,input	wire			ep10_in_buf_ready
	,output	wire			ep10_in_buf_data_commit
	,output	wire	[10:0]	ep10_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT10_OUT
	,input	wire	[31:0]	ep10_out_buf_data
	,input	wire	[10:0]	ep10_out_buf_len
	,input	wire			ep10_out_buf_has_data
	,output wire 			ep10_out_buf_rden
	,output	wire			ep10_out_buf_data_ack 
	`endif		

	`ifdef ENDPT11_IN 
	,output	wire	[31:0]	ep11_in_buf_data
	,output	wire			ep11_in_buf_wren
	,input	wire			ep11_in_buf_ready
	,output	wire			ep11_in_buf_data_commit
	,output	wire	[10:0]	ep11_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT11_OUT
	,input	wire	[31:0]	ep11_out_buf_data
	,input	wire	[10:0]	ep11_out_buf_len
	,input	wire			ep11_out_buf_has_data
	,output wire 			ep11_out_buf_rden
	,output	wire			ep11_out_buf_data_ack 
	`endif		

	`ifdef ENDPT12_IN 
	,output	wire	[31:0]	ep12_in_buf_data
	,output	wire			ep12_in_buf_wren
	,input	wire			ep12_in_buf_ready
	,output	wire			ep12_in_buf_data_commit
	,output	wire	[10:0]	ep12_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT12_OUT
	,input	wire	[31:0]	ep12_out_buf_data
	,input	wire	[10:0]	ep12_out_buf_len
	,input	wire			ep12_out_buf_has_data
	,output wire 			ep12_out_buf_rden
	,output	wire			ep12_out_buf_data_ack 
	`endif		
	
	`ifdef ENDPT13_IN 
	,output	wire	[31:0]	ep13_in_buf_data
	,output	wire			ep13_in_buf_wren
	,input	wire			ep13_in_buf_ready
	,output	wire			ep13_in_buf_data_commit
	,output	wire	[10:0]	ep13_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT13_OUT
	,input	wire	[31:0]	ep13_out_buf_data
	,input	wire	[10:0]	ep13_out_buf_len
	,input	wire			ep13_out_buf_has_data
	,output wire 			ep13_out_buf_rden
	,output	wire			ep13_out_buf_data_ack 
	`endif		
	
	`ifdef ENDPT14_IN 
	,output	wire	[31:0]	ep14_in_buf_data
	,output	wire			ep14_in_buf_wren
	,input	wire			ep14_in_buf_ready
	,output	wire			ep14_in_buf_data_commit
	,output	wire	[10:0]	ep14_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT14_OUT
	,input	wire	[31:0]	ep14_out_buf_data
	,input	wire	[10:0]	ep14_out_buf_len
	,input	wire			ep14_out_buf_has_data
	,output wire 			ep14_out_buf_rden
	,output	wire			ep14_out_buf_data_ack 
	`endif		
	
	
	`ifdef ENDPT15_IN 
	,output	wire	[31:0]	ep15_in_buf_data
	,output	wire			ep15_in_buf_wren
	,input	wire			ep15_in_buf_ready
	,output	wire			ep15_in_buf_data_commit
	,output	wire	[10:0]	ep15_in_buf_data_commit_len
	`endif	
	
	`ifdef ENDPT15_OUT
	,input	wire	[31:0]	ep15_out_buf_data
	,input	wire	[10:0]	ep15_out_buf_len
	,input	wire			ep15_out_buf_has_data
	,output wire 			ep15_out_buf_rden
	,output	wire			ep15_out_buf_data_ack 
	`endif		
	
);



ControlTransfer ControlTransfer_inst
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// requests
	,.request_active 	(request_active	)	
	,.bmRequestType	    (bmRequestType	)
	,.bRequest		    (bRequest		)
	,.wValue			(wValue			)
	,.wIndex			(wIndex			)
	,.wLength	        (wLength	    )

	// ep0 IN  
	,.ep0_in_buf_data		(ep0_in_buf_data	   )
	,.ep0_in_buf_wren       (ep0_in_buf_wren       )
	,.ep0_in_buf_ready      (ep0_in_buf_ready      )
	,.ep0_in_buf_data_commit     (ep0_in_buf_data_commit     )
	,.ep0_in_buf_data_commit_len	(ep0_in_buf_data_commit_len )	

	// ep0 OUT	
	,.ep0_out_buf_data			(ep0_out_buf_data		)	 	
	,.ep0_out_buf_len			(ep0_out_buf_len		)
	,.ep0_out_buf_hasdata		(ep0_out_buf_hasdata	)
	,.ep0_out_buf_rden      	(ep0_out_buf_rden       )
	,.ep0_out_buf_data_ack		(ep0_out_buf_data_ack		)	
	
);


DataTransfer Ep1Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep1_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep1_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep1_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep1_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep1_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep1_out_buf_data	   )
	,.ep1_out_buf_len               (ep1_out_buf_len       )
	,.ep1_out_buf_has_data          (ep1_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep1_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep1_out_buf_data_ack  )
	
);


DataTransfer Ep2Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep2_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep2_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep2_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep2_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep2_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep2_out_buf_data	   )
	,.ep1_out_buf_len               (ep2_out_buf_len       )
	,.ep1_out_buf_has_data          (ep2_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep2_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep2_out_buf_data_ack  )
	
);


DataTransfer Ep3Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep3_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep3_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep3_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep3_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep3_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep3_out_buf_data	   )
	,.ep1_out_buf_len               (ep3_out_buf_len       )
	,.ep1_out_buf_has_data          (ep3_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep3_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep3_out_buf_data_ack  )
	
);

DataTransfer Ep4Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep4_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep4_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep4_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep4_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep4_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep4_out_buf_data	   )
	,.ep1_out_buf_len               (ep4_out_buf_len       )
	,.ep1_out_buf_has_data          (ep4_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep4_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep4_out_buf_data_ack  )
	
);

DataTransfer Ep5Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep5_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep5_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep5_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep5_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep5_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep5_out_buf_data	   )
	,.ep1_out_buf_len               (ep5_out_buf_len       )
	,.ep1_out_buf_has_data          (ep5_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep5_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep5_out_buf_data_ack  )
	
);

DataTransfer Ep6Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep6_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep6_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep6_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep6_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep6_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep6_out_buf_data	   )
	,.ep1_out_buf_len               (ep6_out_buf_len       )
	,.ep1_out_buf_has_data          (ep6_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep6_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep6_out_buf_data_ack  )
	
);

DataTransfer Ep7Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep7_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep7_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep7_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep7_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep7_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep7_out_buf_data	   )
	,.ep1_out_buf_len               (ep7_out_buf_len       )
	,.ep1_out_buf_has_data          (ep7_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep7_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep7_out_buf_data_ack  )
	
);

DataTransfer Ep8Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep8_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep8_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep8_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep8_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep8_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep8_out_buf_data	   )
	,.ep1_out_buf_len               (ep8_out_buf_len       )
	,.ep1_out_buf_has_data          (ep8_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep8_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep8_out_buf_data_ack  )
	
);

DataTransfer Ep9Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep9_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep9_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep9_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep9_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep9_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep9_out_buf_data	   )
	,.ep1_out_buf_len               (ep9_out_buf_len       )
	,.ep1_out_buf_has_data          (ep9_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep9_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep9_out_buf_data_ack  )
	
);

DataTransfer Ep10Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep10_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep10_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep10_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep10_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep10_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep10_out_buf_data	   )
	,.ep1_out_buf_len               (ep10_out_buf_len       )
	,.ep1_out_buf_has_data          (ep10_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep10_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep10_out_buf_data_ack  )
	
);

DataTransfer Ep11Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep11_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep11_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep11_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep11_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep11_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep11_out_buf_data	   )
	,.ep1_out_buf_len               (ep11_out_buf_len       )
	,.ep1_out_buf_has_data          (ep11_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep11_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep11_out_buf_data_ack  )
	
);

DataTransfer Ep12Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep12_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep12_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep12_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep12_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep12_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep12_out_buf_data	   )
	,.ep1_out_buf_len               (ep12_out_buf_len       )
	,.ep1_out_buf_has_data          (ep12_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep12_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep12_out_buf_data_ack  )
	
);

DataTransfer Ep13Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep13_in_buf_data		    )
	,.ep1_in_buf_wren	            (ep13_in_buf_wren	        )
	,.ep1_in_buf_ready              (ep13_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep13_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep13_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep13_out_buf_data	    )
	,.ep1_out_buf_len               (ep13_out_buf_len       )
	,.ep1_out_buf_has_data          (ep13_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep13_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep13_out_buf_data_ack  )
	
);

DataTransfer Ep14Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep14_in_buf_data		   )
	,.ep1_in_buf_wren	            (ep14_in_buf_wren	       )
	,.ep1_in_buf_ready              (ep14_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep14_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep14_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep14_out_buf_data	    )
	,.ep1_out_buf_len               (ep14_out_buf_len       )
	,.ep1_out_buf_has_data          (ep14_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep14_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep14_out_buf_data_ack  )
	
);

DataTransfer Ep15Loopback 
(
	.clk 	(pclk)
	,.rst_n (phy_resetn)

	// ep1 IN 
	,.ep1_in_buf_data				(ep15_in_buf_data		    )
	,.ep1_in_buf_wren	            (ep15_in_buf_wren	        )
	,.ep1_in_buf_ready              (ep15_in_buf_ready          )
	,.ep1_in_buf_data_commit        (ep15_in_buf_data_commit    )
	,.ep1_in_buf_data_commit_len    (ep15_in_buf_data_commit_len)

	
	// ep1 OUT 
	,.ep1_out_buf_data				(ep15_out_buf_data	    )
	,.ep1_out_buf_len               (ep15_out_buf_len       )
	,.ep1_out_buf_has_data          (ep15_out_buf_has_data  )
	,.ep1_out_buf_rden              (ep15_out_buf_rden      )
	,.ep1_out_buf_data_ack          (ep15_out_buf_data_ack  )
	
);






endmodule